/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;

public interface JE2_CabinAccessor extends PAccessor {

	//Accessors to the bedCount field
	public void paSetBedCount(int val) throws PException;
	public int paGetBedCount() throws PException;

	//Accessors to the deckLevel field
	public void paSetDeckLevel(int val) throws PException;
	public int paGetDeckLevel() throws PException;

	//Accessors to the id field
	public void paSetId(java.lang.Integer val) throws PException;
	public java.lang.Integer paGetId() throws PException;

	//Accessors to the jonasCMRCabin_Reservation field
	public void paSetJonasCMRCabin_Reservation(PName val, Object connection) throws PException;
	public PName paGetJonasCMRCabin_Reservation(Object connection) throws PException;

	//Accessors to the name field
	public void paSetName(java.lang.String val) throws PException;
	public java.lang.String paGetName() throws PException;

	//Accessors to the ship field
	public void paSetShip(PName val, Object connection) throws PException;
	public PName paGetShip(Object connection) throws PException;
}
