/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class JE2_CruiseSerializable implements PSerializable, JE2_CruiseAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected java.lang.String name;
			protected  String reservations;
			protected  String ship;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.JE2_Cruise";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetName(java.lang.String val){
		name = val;
	}
	public java.lang.String paGetName() {
		return name;
	}

	public void paSetReservations(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				reservations = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			reservations = "null";
		}
	}
	
	public PName paGetReservations(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("reservations");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(reservations);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetShip(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				ship = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			ship = "null";
		}
	}
	
	public PName paGetShip(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("ship");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(ship);
		}
		catch(PException e){
			return null;
		}
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(name + ",  ");
					s.append(reservations + ",  ");
					s.append(ship + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_CruiseAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof JE2_CruiseAccessor)
			paccessor = (JE2_CruiseAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetName(paGetName());
															paccessor.paSetReservations(paGetReservations(pcm), null);
															paccessor.paSetShip(paGetShip(pcm), null);
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("name", paGetName(pcm), null);
	        			 						 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_CruiseAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof JE2_CruiseAccessor)
			paccessor = (JE2_CruiseAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetName(paccessor.paGetName());
															paSetReservations(paccessor.paGetReservations(pcm), null);
															paSetShip(paccessor.paGetShip(pcm), null);
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 				        	//	paSetStringField(name, paccessorGen.paGetName());
        		//paSetStringField("name", paccessorGen.paGetStringField("name"));
        		//paSetName(paccessorGen.paGetStringField("name"), null);
	        			 						 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}