/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class JE2_AddressSerializable implements PSerializable, JE2_AddressAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected java.lang.String city;
			protected  String jonasCMRCustomer_Address;
			protected java.lang.String state;
			protected java.lang.String street;
			protected java.lang.String zip;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.JE2_Address";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetCity(java.lang.String val){
		city = val;
	}
	public java.lang.String paGetCity() {
		return city;
	}

	public void paSetJonasCMRCustomer_Address(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRCustomer_Address = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRCustomer_Address = "null";
		}
	}
	
	public PName paGetJonasCMRCustomer_Address(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRCustomer_Address");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRCustomer_Address);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetState(java.lang.String val){
		state = val;
	}
	public java.lang.String paGetState() {
		return state;
	}

	public void paSetStreet(java.lang.String val){
		street = val;
	}
	public java.lang.String paGetStreet() {
		return street;
	}

	public void paSetZip(java.lang.String val){
		zip = val;
	}
	public java.lang.String paGetZip() {
		return zip;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(city + ",  ");
					s.append(jonasCMRCustomer_Address + ",  ");
					s.append(state + ",  ");
					s.append(street + ",  ");
					s.append(zip + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_AddressAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof JE2_AddressAccessor)
			paccessor = (JE2_AddressAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetCity(paGetCity());
															paccessor.paSetJonasCMRCustomer_Address(paGetJonasCMRCustomer_Address(pcm), null);
															paccessor.paSetState(paGetState());
															paccessor.paSetStreet(paGetStreet());
															paccessor.paSetZip(paGetZip());
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("city", paGetCity(pcm), null);
	        			 						 			        		//paccessorGen.paSetStringField("state", paGetState(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("street", paGetStreet(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("zip", paGetZip(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_AddressAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof JE2_AddressAccessor)
			paccessor = (JE2_AddressAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetCity(paccessor.paGetCity());
															paSetJonasCMRCustomer_Address(paccessor.paGetJonasCMRCustomer_Address(pcm), null);
															paSetState(paccessor.paGetState());
															paSetStreet(paccessor.paGetStreet());
															paSetZip(paccessor.paGetZip());
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 				        	//	paSetStringField(city, paccessorGen.paGetCity());
        		//paSetStringField("city", paccessorGen.paGetStringField("city"));
        		//paSetCity(paccessorGen.paGetStringField("city"), null);
	        			 						 				        	//	paSetStringField(state, paccessorGen.paGetState());
        		//paSetStringField("state", paccessorGen.paGetStringField("state"));
        		//paSetState(paccessorGen.paGetStringField("state"), null);
	        			 				        	//	paSetStringField(street, paccessorGen.paGetStreet());
        		//paSetStringField("street", paccessorGen.paGetStringField("street"));
        		//paSetStreet(paccessorGen.paGetStringField("street"), null);
	        			 				        	//	paSetStringField(zip, paccessorGen.paGetZip());
        		//paSetStringField("zip", paccessorGen.paGetStringField("zip"));
        		//paSetZip(paccessorGen.paGetStringField("zip"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}